'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Taggy = function Taggy(_ref) {
    var text = _ref.text,
        spans = _ref.spans,
        ents = _ref.ents;

    var jsx = [];
    if (typeof text === 'string') {
        var elements = [];
        var offset = 0;
        spans.forEach(function (_ref2) {
            var type = _ref2.type,
                start = _ref2.start,
                end = _ref2.end;

            var entity = text.slice(start, end);
            var fragment = text.slice(offset, start);
            elements.push(fragment);
            elements.push({
                token: entity,
                type: type.toLowerCase()
            });
            offset = end;
        });
        elements.push(text.slice(offset, text.length));
        elements = elements.filter(function (val) {
            return val !== ' ';
        });
        for (var e = 0; e < elements.length; e++) {
            if (elements[e].token) {
                for (var i = e + 1; i < elements.length; i++) {
                    if (typeof elements[i] !== 'string' && elements[i].type === elements[e].type) {
                        elements[e].token += ' ' + elements[i].token;
                        elements[i] = false;
                    }
                    if (typeof elements[i] === 'string') {
                        break;
                    }
                }
            }
        }
        elements = elements.filter(function (val) {
            return !!val;
        });
        elements.forEach(function (t) {
            if (typeof t === 'string') {
                jsx.push(t);
            } else {
                jsx.push(_react2.default.createElement(
                    'mark',
                    {
                        className: 'outer-taggy',
                        style: {
                            background: 'rgba(\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.r + ',\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.g + ',\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.b + ',\n                                0.2\n                            )',
                            borderColor: 'rgb(\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.r + ',\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.g + ',\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.b + '\n                            )'
                        }
                    },
                    t.token,
                    _react2.default.createElement(
                        'span',
                        {
                            className: 'inner-taggy',
                            style: {
                                background: 'rgb(\n                                    ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.r + ',\n                                    ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.g + ',\n                                    ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.b + '\n                                )'
                            }
                        },
                        t.type.toLowerCase()
                    )
                ));
            }
        });
    }
    if (Array.isArray(text)) {
        var tokens = text;
        for (var s = 0; s < spans.length; s++) {
            tokens[spans[s].index] = {
                token: tokens[spans[s].index],
                type: spans[s].type.toLowerCase()
            };
        }
        for (var t = 0; t < tokens.length; t++) {
            if (tokens[t].token) {
                for (var _i = t + 1; _i < tokens.length; _i++) {
                    if (typeof tokens[_i] !== 'string' && tokens[_i].type === tokens[t].type) {
                        tokens[t].token += ' ' + tokens[_i].token;
                        tokens[_i] = false;
                    }
                    if (typeof tokens[_i] === 'string') {
                        break;
                    }
                }
            }
        }
        tokens = tokens.filter(function (val) {
            return !!val;
        });
        var tokensWithSpaces = tokens.map(function (t) {
            if (typeof t === 'string') {
                return t + ' ';
            }
            return t;
        });
        tokensWithSpaces.forEach(function (t) {
            if (typeof t === 'string') {
                jsx.push(t);
            } else {
                jsx.push(_react2.default.createElement(
                    'mark',
                    {
                        className: 'outer-taggy',
                        style: {
                            background: 'rgba(\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.r + ',\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.g + ',\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.b + ',\n                                0.2\n                            )',
                            borderColor: 'rgb(\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.r + ',\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.g + ',\n                                ' + ents.find(function (ent) {
                                return ent.type === t.type;
                            }).color.b + '\n                            )'
                        }
                    },
                    t.token,
                    _react2.default.createElement(
                        'span',
                        {
                            className: 'inner-taggy',
                            style: {
                                background: 'rgb(\n                                    ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.r + ',\n                                    ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.g + ',\n                                    ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.b + '\n                                )'
                            }
                        },
                        t.type.toLowerCase()
                    )
                ));
            }
        });
    }
    return _react2.default.createElement(
        'div',
        null,
        jsx.map(function (j, i) {
            return _react2.default.createElement(
                'span',
                { key: i },
                j
            );
        })
    );
};

exports.default = Taggy;